package com.syc.slm.common.core.util;

import com.syc.slm.slmbi.exception.SysException;
import com.syc.slm.slmbi.function.Action0;

import java.util.function.Supplier;

/**
 * slm-bi
 * 统一方法调用返回
 *
 * @author : lin
 * @date : 2021-04-06 09:39
 **/
public final class NetResponseUtils {
    public static <T> R<T> call(Supplier<T> x) {
        try {
            return R.ok(x.get());
        } catch (Exception ex) {
            ex.printStackTrace();
            if ((ex.getCause() instanceof SysException)) {
                SysException e = (SysException)ex.getCause();
                return R.failed(e.getMsg());
            }
            return R.failed(ex.getMessage());
        }
    }

    public static R<Object> call(Action0 x) {
        try {
            x.call();
            return R.ok();
        } catch (Exception ex) {
            ex.printStackTrace();
            return R.failed(ex.getMessage());
        }
    }
}
