package com.syc.slm.slmbi.config;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.function.Supplier;

/**
 * mybatisplus自定义填充公共字段 ,即没有传的字段自动填充
 * @author lin
 * @date 2021-04-01 10:52:44
 */
@Component
@Slf4j
public class SysMetaObjectHandler implements MetaObjectHandler {

    private static final String APP_ID = "appId";
    private static final String CREATOR = "creator";
    private static final String CREATOR_NAME = "creatorName";
    private static final String CREATE_TIME = "createTime";
    private static final String UPDATER = "updater";
    private static final String UPDATER_NAME = "updaterName";
    private static final String UPDATE_TIME = "updateTime";
    private static final String RECORD_STATUS = "recordStatus";

    /**
     * 插入使用
     */
    @Override
    public void insertFill(MetaObject metaObject) {
        fillValue(metaObject,
                  APP_ID,
                  () -> (metaObject.getValue(APP_ID) == null ? "68d61d7f990e11eb847e88d7f63cc98f" : metaObject.getValue(APP_ID)));
        fillValue(metaObject,
                  CREATOR,
                  () -> (metaObject.getValue(CREATOR) == null ? "68d61d7f990e11eb847e88d7f63cc98f" : metaObject.getValue(CREATOR)));
        fillValue(metaObject,
                  CREATOR_NAME,
                  () -> (metaObject.getValue(CREATOR_NAME) == null ? "小明" : metaObject.getValue(CREATOR_NAME)));
        fillValue(metaObject,
                  CREATE_TIME,
                  () -> (metaObject.getValue(CREATE_TIME) == null ? new Date() : metaObject.getValue(CREATE_TIME)));
        fillValue(metaObject,
                  RECORD_STATUS,
                  () -> (metaObject.getValue(RECORD_STATUS) == null ? 1 : metaObject.getValue(RECORD_STATUS)));
    }

    @Override
    public void updateFill(MetaObject metaObject) {
        setFieldValByName(UPDATER, "68d61d7f990e11eb847e88d7f63cc98f", metaObject);
        setFieldValByName(UPDATER_NAME, "小明",metaObject);
        setFieldValByName(UPDATE_TIME, new Date(), metaObject);
    }

    private void fillValue(MetaObject metaObject, String fieldName, Supplier<?> valueSupplier) {
        if (!metaObject.hasGetter(fieldName)) {
            return;
        }
        Object sidObj = metaObject.getValue(fieldName);
        if (sidObj == null && metaObject.hasSetter(fieldName) && valueSupplier != null) {
            setFieldValByName(fieldName, valueSupplier.get(), metaObject);
        }
    }

}
